function [c]=covar2(sig,a,N) 
%COVAR2    Determines covariances of sig(z)/a(z) up to order N 
n_a=length(a)-1; 
n_sig=length(sig)-1; 
n_a_sig=n_a+n_sig; 

% Computes the covariances of the AR-part up to order n 

k=invlevinson(a/a(1));

%n=length(a)-1; 
%alpha(n+1,:)=a; 
%for l=n:-1:1 
%  K(l)=-alpha(l+1,l+1); 
%  alpha(l,2:l)=(alpha(l+1,2:l)+K(l)*fliplr(alpha(l+1,2:l)))/(1-K(l)^2); 
%end 

r=invschur(k)'; 
%n=length(K); 
%yu=zeros(n+1); yut=zeros(n+1); c=zeros(1,n+1); 
%yu(1,1)  = prod( 1./(1-K.^2) ); 
%yut(1,1) = yu(1,1); 
%c(1)     = yu(1,1); 
% 
%for k=1:n 
%  for l=k:-1:1 
%    yu(k+1,l)= yu(k+1,l+1)+K(l)*yut(k-l+1,l); 
%    yut(k-l+1,l+1)=-K(l)*yu(k+1,l+1)+(1-K(l)^2)*yut(k-l+1,l); 
%  end 
%  yut(k+1,1) = yu(k+1,1); 
%  c(k+1)     = yu(k+1,1); 
%end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5 
  

% Continues the covariances of the AR-part up to order n+N 
for l=n_a+1:n_a+n_sig+N 
  r(l+1)=-fliplr(a(2:n_a+1))*r(l-n_a+1:l)/a(1); 
end 

% Take the effect of the MA-part into account 
s=sig/a(1); 
r2=[fliplr(r') r(2:length(r))']; 
cn=conv( conv(fliplr(s),s), r2);
c=cn((length(cn)+1)/2:(length(cn)+1)/2+N);

% The last part above is just a faster way to 
% compute the following triple sum. 
% 
%for m=0:n_a,        zum=0; 
%  for k=0:n_sig 
%    for l=0:n_sig 
%      zum=zum+s(k+1)*s(l+1)*r(abs(m-k+l)+1); 
%    end 
%  end 
%  cn(m+1)=zum; 
%end 
 
