%
%   This function symbolically differentiates a rational function of two 
%    polynomials, a & b:
%           b                    b'*a - b*a'     d
%      f = ---       ->    f' = ------------- = ---
%           a                        a*a         c
%
function [d,c] = rationaldiff(b,a)

bdif=b(1:end-1).*((length(b)-1):-1:1);
adif=a(1:end-1).*((length(a)-1):-1:1);
d = conv(bdif,a)-conv(adif,b);
c = conv(a,a);
