%
%   This function extends a interpolation data set to become
%    self-conjugated.
%
function interdata = selfconj(interdata)

z = interdata.z;
w = interdata.w;
speczeros = interdata.speczeros;

for k = 1:length(speczeros)
    if abs(imag(speczeros(k))) > 10*eps
        speczeros(end+1) = conj(speczeros(k));
    end
end
  
for k = 1:interdata.ntilde
    if abs(imag(z(k))) > 10*eps
        z(end+1) = conj(z(k));
        w{end+1} = conj(w{k}); 
    elseif norm(imag(w{k})) > 1000*eps,
        disp('In selfconj: real interpolation points should')
        disp('      correspond to real interpolation values')
        return
    else 
        z(k) = real(z(k)); 
        w{k} = real(w{k});
    end
end

interdata = getinterdata(z,w,speczeros);